using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp19
{
    class Program
    {
        static void Main(string[] args)
        {
            string linija = Console.ReadLine();
            int N = int.Parse(linija.Split(' ')[0]);
            int M = int.Parse(linija.Split(' ')[1]);
            int[,] matrica = new int[N, M];
            for (int i = 0; i < N; i++)
            {
                linija = Console.ReadLine();
                for (int j = 0; j < M; j++)
                {
                    matrica[i, j] = int.Parse(linija.Split(' ')[j]);
                }
            }
            int Q = int.Parse(Console.ReadLine());
            for (int k = 0; k < Q; k++)
            {
                linija = Console.ReadLine();
                int x = int.Parse(linija.Split(' ')[0]) - 1; int y = int.Parse(linija.Split(' ')[1]) - 1;
                int pX = 0, pY = 0;
                int sabirak1 = 0;
                while (pX != M - 1 || pY != N - 1)
                {

                    if (pX + 1 != y || pY != x)
                    {
                        if (pY + 1 != x || pX != y)
                        {
                            if (pX < M - 1)
                            {
                                if (pY < N - 1)
                                {
                                    if (matrica[pY, pX + 1] < matrica[pY + 1, pX]) { sabirak1 = sabirak1 + matrica[pY, pX]; pX++; }
                                    else { sabirak1 = sabirak1 + matrica[pY, pX]; pY++; }
                                }
                                else
                                {
                                    sabirak1 = sabirak1 + matrica[pY, pX];
                                    pX++;
                                }
                            }

                            else if (pY < N - 1)
                            {
                                sabirak1 = sabirak1 + matrica[pY, pX];
                                pY++;
                            }
                        }
                        else if (pX == M - 1) { pX--;pY++; }
                    else
                    {
                        sabirak1 = sabirak1 + matrica[pY, pX];
                        pX++;
                    }
                    }
                    else if (pY == N - 1) { pY--;pX++; }
                    else 
                    {                         
                        sabirak1 = sabirak1 + matrica[pY, pX]; pY++;
                    }
                    if (pX == M - 1 && pY == N - 1) { sabirak1 = sabirak1 + matrica[pY, pX]; }
                }

                Console.WriteLine(sabirak1);             
            }

        }
    }
}